// This file is automatically generated!

using System;
using System.Runtime.InteropServices;

namespace Steamworks {
	public static class SteamRemoteStorage {
		public static bool FileWrite(string pchFile, IntPtr pvData, int cubData) {
			return NativeMethods.ISteamRemoteStorage_FileWrite(new InteropHelp.UTF8String(pchFile), pvData, cubData);
		}

		public static int FileRead(string pchFile, IntPtr pvData, int cubDataToRead) {
			return NativeMethods.ISteamRemoteStorage_FileRead(new InteropHelp.UTF8String(pchFile), pvData, cubDataToRead);
		}

		public static bool FileForget(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FileForget(new InteropHelp.UTF8String(pchFile));
		}

		public static bool FileDelete(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FileDelete(new InteropHelp.UTF8String(pchFile));
		}

		public static ulong FileShare(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FileShare(new InteropHelp.UTF8String(pchFile));
		}

		public static bool SetSyncPlatforms(string pchFile, ERemoteStoragePlatform eRemoteStoragePlatform) {
			return NativeMethods.ISteamRemoteStorage_SetSyncPlatforms(new InteropHelp.UTF8String(pchFile), eRemoteStoragePlatform);
		}

		public static ulong FileWriteStreamOpen(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FileWriteStreamOpen(new InteropHelp.UTF8String(pchFile));
		}

		public static bool FileWriteStreamWriteChunk(ulong writeHandle, IntPtr pvData, int cubData) {
			return NativeMethods.ISteamRemoteStorage_FileWriteStreamWriteChunk(writeHandle, pvData, cubData);
		}

		public static bool FileWriteStreamClose(ulong writeHandle) {
			return NativeMethods.ISteamRemoteStorage_FileWriteStreamClose(writeHandle);
		}

		public static bool FileWriteStreamCancel(ulong writeHandle) {
			return NativeMethods.ISteamRemoteStorage_FileWriteStreamCancel(writeHandle);
		}

		public static bool FileExists(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FileExists(new InteropHelp.UTF8String(pchFile));
		}

		public static bool FilePersisted(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FilePersisted(new InteropHelp.UTF8String(pchFile));
		}

		public static int GetFileSize(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_GetFileSize(new InteropHelp.UTF8String(pchFile));
		}

		public static long GetFileTimestamp(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_GetFileTimestamp(new InteropHelp.UTF8String(pchFile));
		}

		public static ERemoteStoragePlatform GetSyncPlatforms(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_GetSyncPlatforms(new InteropHelp.UTF8String(pchFile));
		}

		public static int GetFileCount() {
			return NativeMethods.ISteamRemoteStorage_GetFileCount();
		}

		public static string GetFileNameAndSize(int iFile, out int pnFileSizeInBytes) {
			return InteropHelp.PtrToStringUTF8(NativeMethods.ISteamRemoteStorage_GetFileNameAndSize(iFile, out pnFileSizeInBytes));
		}

		public static bool GetQuota(out int pnTotalBytes, out int puAvailableBytes) {
			return NativeMethods.ISteamRemoteStorage_GetQuota(out pnTotalBytes, out puAvailableBytes);
		}

		public static bool IsCloudEnabledForAccount() {
			return NativeMethods.ISteamRemoteStorage_IsCloudEnabledForAccount();
		}

		public static bool IsCloudEnabledForApp() {
			return NativeMethods.ISteamRemoteStorage_IsCloudEnabledForApp();
		}

		public static void SetCloudEnabledForApp(bool bEnabled) {
			NativeMethods.ISteamRemoteStorage_SetCloudEnabledForApp(bEnabled);
		}

		public static ulong UGCDownload(ulong hContent, uint unPriority) {
			return NativeMethods.ISteamRemoteStorage_UGCDownload(hContent, unPriority);
		}

		public static bool GetUGCDownloadProgress(ulong hContent, out int pnBytesDownloaded, out int pnBytesExpected) {
			return NativeMethods.ISteamRemoteStorage_GetUGCDownloadProgress(hContent, out pnBytesDownloaded, out pnBytesExpected);
		}

		public static bool GetUGCDetails(ulong hContent, out uint pnAppID, IntPtr ppchName, out int pnFileSizeInBytes, IntPtr pSteamIDOwner) {
			return NativeMethods.ISteamRemoteStorage_GetUGCDetails(hContent, out pnAppID, ppchName, out pnFileSizeInBytes, pSteamIDOwner);
		}

		public static int UGCRead(ulong hContent, IntPtr pvData, int cubDataToRead, uint cOffset, EUGCReadAction eAction) {
			return NativeMethods.ISteamRemoteStorage_UGCRead(hContent, pvData, cubDataToRead, cOffset, eAction);
		}

		public static int GetCachedUGCCount() {
			return NativeMethods.ISteamRemoteStorage_GetCachedUGCCount();
		}

		public static ulong GetCachedUGCHandle(int iCachedContent) {
			return NativeMethods.ISteamRemoteStorage_GetCachedUGCHandle(iCachedContent);
		}
#if _PS3 || _SERVER
		public static void GetFileListFromServer() {
			NativeMethods.ISteamRemoteStorage_GetFileListFromServer();
		}

		public static bool FileFetch(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FileFetch(new InteropHelp.UTF8String(pchFile));
		}

		public static bool FilePersist(string pchFile) {
			return NativeMethods.ISteamRemoteStorage_FilePersist(new InteropHelp.UTF8String(pchFile));
		}

		public static bool SynchronizeToClient() {
			return NativeMethods.ISteamRemoteStorage_SynchronizeToClient();
		}

		public static bool SynchronizeToServer() {
			return NativeMethods.ISteamRemoteStorage_SynchronizeToServer();
		}

		public static bool ResetFileRequestState() {
			return NativeMethods.ISteamRemoteStorage_ResetFileRequestState();
		}
#endif
		public static ulong PublishWorkshopFile(string pchFile, string pchPreviewFile, uint nConsumerAppId, string pchTitle, string pchDescription, ERemoteStoragePublishedFileVisibility eVisibility, IntPtr pTags, EWorkshopFileType eWorkshopFileType) {
			return NativeMethods.ISteamRemoteStorage_PublishWorkshopFile(new InteropHelp.UTF8String(pchFile), new InteropHelp.UTF8String(pchPreviewFile), nConsumerAppId, new InteropHelp.UTF8String(pchTitle), new InteropHelp.UTF8String(pchDescription), eVisibility, pTags, eWorkshopFileType);
		}

		public static ulong CreatePublishedFileUpdateRequest(ulong unPublishedFileId) {
			return NativeMethods.ISteamRemoteStorage_CreatePublishedFileUpdateRequest(unPublishedFileId);
		}

		public static bool UpdatePublishedFileFile(ulong updateHandle, string pchFile) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFileFile(updateHandle, new InteropHelp.UTF8String(pchFile));
		}

		public static bool UpdatePublishedFilePreviewFile(ulong updateHandle, string pchPreviewFile) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFilePreviewFile(updateHandle, new InteropHelp.UTF8String(pchPreviewFile));
		}

		public static bool UpdatePublishedFileTitle(ulong updateHandle, string pchTitle) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFileTitle(updateHandle, new InteropHelp.UTF8String(pchTitle));
		}

		public static bool UpdatePublishedFileDescription(ulong updateHandle, string pchDescription) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFileDescription(updateHandle, new InteropHelp.UTF8String(pchDescription));
		}

		public static bool UpdatePublishedFileVisibility(ulong updateHandle, ERemoteStoragePublishedFileVisibility eVisibility) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFileVisibility(updateHandle, eVisibility);
		}

		public static bool UpdatePublishedFileTags(ulong updateHandle, IntPtr pTags) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFileTags(updateHandle, pTags);
		}

		public static ulong CommitPublishedFileUpdate(ulong updateHandle) {
			return NativeMethods.ISteamRemoteStorage_CommitPublishedFileUpdate(updateHandle);
		}

		public static ulong GetPublishedFileDetails(ulong unPublishedFileId, uint unMaxSecondsOld) {
			return NativeMethods.ISteamRemoteStorage_GetPublishedFileDetails(unPublishedFileId, unMaxSecondsOld);
		}

		public static ulong DeletePublishedFile(ulong unPublishedFileId) {
			return NativeMethods.ISteamRemoteStorage_DeletePublishedFile(unPublishedFileId);
		}

		public static ulong EnumerateUserPublishedFiles(uint unStartIndex) {
			return NativeMethods.ISteamRemoteStorage_EnumerateUserPublishedFiles(unStartIndex);
		}

		public static ulong SubscribePublishedFile(ulong unPublishedFileId) {
			return NativeMethods.ISteamRemoteStorage_SubscribePublishedFile(unPublishedFileId);
		}

		public static ulong EnumerateUserSubscribedFiles(uint unStartIndex) {
			return NativeMethods.ISteamRemoteStorage_EnumerateUserSubscribedFiles(unStartIndex);
		}

		public static ulong UnsubscribePublishedFile(ulong unPublishedFileId) {
			return NativeMethods.ISteamRemoteStorage_UnsubscribePublishedFile(unPublishedFileId);
		}

		public static bool UpdatePublishedFileSetChangeDescription(ulong updateHandle, string pchChangeDescription) {
			return NativeMethods.ISteamRemoteStorage_UpdatePublishedFileSetChangeDescription(updateHandle, new InteropHelp.UTF8String(pchChangeDescription));
		}

		public static ulong GetPublishedItemVoteDetails(ulong unPublishedFileId) {
			return NativeMethods.ISteamRemoteStorage_GetPublishedItemVoteDetails(unPublishedFileId);
		}

		public static ulong UpdateUserPublishedItemVote(ulong unPublishedFileId, bool bVoteUp) {
			return NativeMethods.ISteamRemoteStorage_UpdateUserPublishedItemVote(unPublishedFileId, bVoteUp);
		}

		public static ulong GetUserPublishedItemVoteDetails(ulong unPublishedFileId) {
			return NativeMethods.ISteamRemoteStorage_GetUserPublishedItemVoteDetails(unPublishedFileId);
		}

		public static ulong EnumerateUserSharedWorkshopFiles(ulong steamId, uint unStartIndex, IntPtr pRequiredTags, IntPtr pExcludedTags) {
			return NativeMethods.ISteamRemoteStorage_EnumerateUserSharedWorkshopFiles(steamId, unStartIndex, pRequiredTags, pExcludedTags);
		}

		public static ulong PublishVideo(EWorkshopVideoProvider eVideoProvider, string pchVideoAccount, string pchVideoIdentifier, string pchPreviewFile, uint nConsumerAppId, string pchTitle, string pchDescription, ERemoteStoragePublishedFileVisibility eVisibility, IntPtr pTags) {
			return NativeMethods.ISteamRemoteStorage_PublishVideo(eVideoProvider, new InteropHelp.UTF8String(pchVideoAccount), new InteropHelp.UTF8String(pchVideoIdentifier), new InteropHelp.UTF8String(pchPreviewFile), nConsumerAppId, new InteropHelp.UTF8String(pchTitle), new InteropHelp.UTF8String(pchDescription), eVisibility, pTags);
		}

		public static ulong SetUserPublishedFileAction(ulong unPublishedFileId, EWorkshopFileAction eAction) {
			return NativeMethods.ISteamRemoteStorage_SetUserPublishedFileAction(unPublishedFileId, eAction);
		}

		public static ulong EnumeratePublishedFilesByUserAction(EWorkshopFileAction eAction, uint unStartIndex) {
			return NativeMethods.ISteamRemoteStorage_EnumeratePublishedFilesByUserAction(eAction, unStartIndex);
		}

		public static ulong EnumeratePublishedWorkshopFiles(EWorkshopEnumerationType eEnumerationType, uint unStartIndex, uint unCount, uint unDays, IntPtr pTags, IntPtr pUserTags) {
			return NativeMethods.ISteamRemoteStorage_EnumeratePublishedWorkshopFiles(eEnumerationType, unStartIndex, unCount, unDays, pTags, pUserTags);
		}

		public static ulong UGCDownloadToLocation(ulong hContent, string pchLocation, uint unPriority) {
			return NativeMethods.ISteamRemoteStorage_UGCDownloadToLocation(hContent, new InteropHelp.UTF8String(pchLocation), unPriority);
		}
	}
}